from random import randint
import fxconv
import json
import pathlib
import csv

def convert(input, output, params, target):
  if params["custom-type"] == "map":
    convert_map(input, output, params, target)
    return 0
  else:
    return 1

def fix(x):
  return int(x*2**16)

def pix2pos(x):
  return fix(x/64)

def convert_map(input, output, params, target):
  print("Converting map", params["name"])

  data = json.load(open(input, "r"))

  #Extract from the json the width, height
  #w, h = data["width"], data["height"]

  structMap = fxconv.Structure()

  #structMap += fxconv.u32(w)
  #structMap += fxconv.u32(h)
  structMap += fxconv.u32(fix(4))    #startpos_x - a implémenter dans Tiled
  structMap += fxconv.u32(fix(4))    #startpos_y
  structMap += fxconv.u32(fix(4))    #startdir_x
  structMap += fxconv.u32(fix(0))    #startdir_y
  structMap += fxconv.u32(fix(0))	   #startplane_x
  structMap += fxconv.u32(fix(0.66)) #startplane_y

  data_f = data["layers"][0]["data"] #Floor data
  data_w = data["layers"][1]["data"] #Wall data layer 0
  data_w += data["layers"][2]["data"] #Wall data 1
  data_w += data["layers"][3]["data"] #Wall data 2

  data_s = data["layers"][4]["objects"] #sprite data


  for i in range(1, 128**2):
    structMap += fxconv.u8(data_f[i])

  for i in range(0, 128**2*3):
    #Opt for empty spaces/outdoors, if the whole vert. stack == 0 it will be skipped
    if i<128*128 and data_w[i+128*128]==0 and data_w[i+128*128*2]==0 :
      structMap += fxconv.u8(255)
    else :
      structMap += fxconv.u8(data_w[i])

  i = 0
  #for i in data_s and i < 256:
  #  stemp = fxconv.Structure()
  #  #stemp += fxconv.u32(pix2pos(data_s[i]["x"])) #l'adressage est mauvais
  #  #stemp += fxconv.u32(pix2pos(data_s[i]["y"]))
  #  stemp += fxconv.u32(fix(10))
  #  stemp += fxconv.u32(fix(10))
  #  stemp += fxconv.u8(0) #temp
  #  structMap += stemp

  #generate !
  fxconv.elf(structMap, output, "_" + params["name"], **target)
