#include "includes.h"

#include "inputs.h"
#include "utils.h"
#include "types.h"
#include "moteur.h"

#ifdef FXCG50

//The actual keys behind the RCKEY_ ones
uint8_t keymap[] = {0, KEY_UP, KEY_DOWN, KEY_LEFT, KEY_RIGHT, KEY_ALPHA,
                   KEY_SHIFT, KEY_F6, KEY_F1, KEY_TAN};

inline void rc_pollevent() {
  pollevent();
}

inline uint8_t rc_keydown(enum keys key) {
  switch(key){
    case -1:{return 1;} //Temp
    case 0: {return 0;}
    default:{return keydown(keymap[key]);}
  }
  return 255;
}
//To reimplement
uint8_t rc_getkey(enum keys key) {
  dupdate();

  return 255;
}

void keys_get(Game *game){
  Player *player = game->player;
  ShooterMap *shooterLevel = game->shooterLevel;

  extern char screenshot;
  extern char record;
  extern char capture_timer;
  extern char frame_time_timer;
  extern char disp_frame_time;
  extern char exit_game;

  pollevent();

  uint8_t keydowns = rc_keydown(RCKEY_UP) | rc_keydown(RCKEY_DOWN) << 1 | rc_keydown(RCKEY_LEFT) << 2
                       | rc_keydown(RCKEY_RIGHT) << 3 | rc_keydown(RCKEY_JUMP) << 4;

  move(game, keydowns);

  if(rc_keydown(RCKEY_FPS) && frame_time_timer <= 0) {
    if(disp_frame_time == 0) {
      disp_frame_time = 1;
      frame_time_timer = 10;
    }
  }
  frame_time_timer--;
  if(rc_keydown(RCKEY_EXIT)) exit_game = 1;

  #ifdef debug
  if(rc_keydown(RCKEY_DEBUG)) {}//end_screen();
  #endif

  #ifdef USB
  screenshot = 0;
  if(rc_keydown(RCKEY_DEBUG) && keydown(RCKEY_ACTION) && capture_timer <= 0) {
    if(screenshot == 0) screenshot = 1;
    capture_timer = 10;
  }
  capture_timer--;
  #endif
}


#endif

#ifdef SDL2
//This SDL2 part is very unfinished

//The actual keys behind the RCKEY_ ones
// W = move fowards
// S = move backwards
// Q = turn left
// D = turn right
// Space = jump
// F = interact
// Esc = exit
// F1 = FPS counter
// G = Debug

uint8_t keymap[] = {0, SDL_SCANCODE_W, SDL_SCANCODE_S, SDL_SCANCODE_Q, SDL_SCANCODE_D,
                   SDL_SCANCODE_SPACE, SDL_SCANCODE_F, SDL_SCANCODE_ESCAPE,
                   SDL_SCANCODE_F1, SDL_SCANCODE_G};

SDL_Event sdl_event;

void rc_pollevent(){
  extern SDL_Event sdl_event;

  SDL_PumpEvents();
}

uint8_t rc_keydown(enum keys key){



  return 1;
}
//To reimplement
uint8_t rc_getkey(enum keys key) {
  dupdate();

}

void keys_get(Game *game){
  Player *player = game->player;
  ShooterMap *shooterLevel = game->shooterLevel;

  extern char screenshot;
  extern char record;
  extern char capture_timer;
  extern char frame_time_timer;
  extern char disp_frame_time;
  extern char exit_game;


  uint8_t keydowns = rc_keydown(RCKEY_UP) || rc_keydown(RCKEY_DOWN) << 1 || rc_keydown(RCKEY_LEFT) << 2
                       || rc_keydown(RCKEY_RIGHT) << 3 |  rc_keydown(RCKEY_JUMP) << 4;

  move(game, keydowns);

  if(rc_keydown(RCKEY_FPS) && frame_time_timer <= 0) {
    if(disp_frame_time == 0) {
      disp_frame_time = 1;
      frame_time_timer = 10;
    }
  }
  frame_time_timer--;
  if(rc_keydown(RCKEY_EXIT)) exit_game = 1;

  #ifdef debug
  if(rc_keydown(RCKEY_DEBUG)) {}//end_screen();
  #endif

  #ifdef USB
  screenshot = 0;
  if(rc_keydown(RCKEY_DEBUG) && keydown(RCKEY_ACTION) && capture_timer <= 0) {
    if(screenshot == 0) screenshot = 1;
    capture_timer = 10;
  }
  capture_timer--;
  #endif
}

#endif

