#ifdef FX9860G
#error "Ce code n'est pas pour FX, enlevez ce message a vos riques et périls"
#endif

#include "includes.h"

#include "sprites.h"
#include "map.h"
#include "moteur.h"
#include "player.h"
#include "utils.h"
#include "types.h"
#include "inputs.h"
#include "ui.h"

//====== ShooterGeam V 0.6 =====
// Git du moteur : https://gitea.planet-casio.com/Fcalva/Raycaster_G90
//
// Game design : Fcalva (aka. fklv, Fcalva#6860, attilavs2)
// Programmation : Fcalva
//                 Personnes créditées à travers le code
// "Art" : Fcalva
//
// Remerciments à : SlyVTT pour l'aide et ses bouts de code
//				    Lephenixnoir pour Gint et l'aide
// Pour le moment le nouveau moteur de rendu 3lvl  ne marche pas
// TODO :
//    - Nouveau mouvement |~| (Cassé mais marchait)
//    - 3 Level |~| (Textures sont cassées)
//    - Sprites ! |~|
//    - SDL (voir sdl_image.h) |~| (entrées a faire)
//

#ifdef FXCG50
//extern image_t briques0;
//extern image_t buisson0;
#endif

Player player1;

char exit_game = 0;
char disp_frame_time = 0;
char first_frame = 1;
int frame_time_timer = 1;
int capture_timer = 1;

int frame_time = 0;
int raycast_time = 0;
int draw_time = 0;

int main(){

  #ifdef SDL2
  sdl_image_init();
  image_t briques0 = sdl_tex_load("assets-cg/textures/briques0.png");
  image_t buisson0 = sdl_tex_load("assets-cg/textures/buisson1.png");

  #endif

  dclear(C_WHITE);
  dprint( 0, 0, C_BLACK, "Chargement...");
  dupdate();
  dclear(C_WHITE); //getkey();

  //trucs de chargement

  image_t *vram = image_create_vram();
  /*image_t *sky_tex = image_alloc(64, 64, IMAGE_RGB565);
  image_t *D_tex = image_alloc(64, 64, IMAGE_RGB565);

  image_fill(D_tex, C_DGRAY);
  image_fill(sky_tex, C_BSKY);*/

  extern image_t *tex_index[tindex_size];
  //tex_index[0] = D_tex;
  //tex_index[1] = &buisson0;
  //tex_index[2] = &briques0;
  //tex_index[3] = sky_tex;

  prof_init();

  Game game;
  Player player;
  game.player = &player;
  load_map(&game, 0);

  player.pos.x = fix(3);
  player.pos.y = fix(3);
  player.pos.z = fix(0);
  player.velocity.x = 0;
  player.velocity.y = 0;
  player.velocity.z = 0;
  player.dir.x = 0xFFFF;
  player.dir.y = 0x0;
  player.plane.x = 0x0;
  player.plane.y = fix(-0.66F);
  player.speed_mult = 0xFFFF;



  while (exit_game == 0) {
    prof_t frame = prof_make();
    prof_enter(frame);

    dclear(C_WHITE);

    //draw_sprites(&zombard, &ShooterLevel0, &player1);

    draw_walls(&game, vram);

    //if(first_frame == 1) main_menu();

    keys_get(&game);

    //logic();

    if (disp_frame_time == 1) dprint( 1, 1, C_BLACK, "Frame time : %d ms", frame_time);

    #ifdef debug

      dprint( 1, 10,C_BLACK, "Raycast time : %d ms", raycast_time);
      dprint( 1, 20,C_BLACK, "Draw time : %d ms", draw_time);
      dprint( 1, 30, C_BLACK, "planeX : %d", player1.plane.x);
      dprint( 1, 40, C_BLACK, "planeY : %d", player1.plane.y);
      dprint( 1, 50, C_BLACK, "dirX : %d", player1.dir.x);
      dprint( 1, 60, C_BLACK, "dirY : %d", player1.dir.y);
      dprint( 1, 70, C_BLACK, "posX : %d", player1.pos.x);
      dprint( 1, 80, C_BLACK, "posY : %d", player1.pos.y);
      dprint( 1, 90, C_BLACK, "posZ : %d", player1.pos.z);
      #ifdef FXCG50
        dprint( 1, 130, C_BLACK, "RAM usage : %d",
          kmalloc_get_gint_stats(kmalloc_get_arena("_uram"))->used_memory);
      #endif
    #endif

    dupdate();

   // exit_game = 0;

    prof_leave(frame);
    frame_time = (int)prof_time(frame)/1000;
  }

  prof_quit();


  #ifdef USB
  usb_close();
  #endif

  //image_free(vram);
  //image_free(&briques0);
  //image_free(&buisson0);
  //image_free(sky_tex);
  //image_free(D_tex);

  #ifdef SDL2
  sdl_image_quit();
  #endif

  return 1;
}
