#include "includes.h"

#include "types.h"
#include "utils.h"

void draw_map_sprites(image_t *sprite, ShooterMap *ShooterLevel, Player *player) {

    // TODO : Add pre-clipping
    //This sorts the sprites by distance, before prunning the ones further than max_sprite_dist
    //Then it adds the remaining ones to the render queue, starting from furthest

    Sprite *sprite_list;
    fixed_t *dist_list;
    int count;
    int a_count = 0; //Actual count
    fixed_t *base;
    fixed_t *result;
    int list_pos;
    int i;

    count = ShooterLevel->sprite_count < max_sprite_search ? ShooterLevel->sprite_count:max_sprite_search;

    dist_list = malloc(sizeof(fixed_t) * count * 2);

    for(i = 0; i < count; i++){
        dist_list[i] = fmul(player->pos.x - ShooterLevel->sprites[i].pos_x, player->pos.x - ShooterLevel->sprites[i].pos_x)
                         + fmul(player->pos.y - ShooterLevel->sprites[i].pos_y, player->pos.y - ShooterLevel->sprites[i].pos_y);
        dist_list[i+count] = dist_list[i]; //Stash another for relink
    }

    qsort(dist_list, count, sizeof(fixed_t), &cmpfunc);

    base = &dist_list[count];

    count = ShooterLevel->sprite_count < max_sprite_display ? ShooterLevel->sprite_count:max_sprite_display;

    sprite_list = malloc(sizeof(Sprite) * count);

    for(i = 0; i < count; i++){
        if(dist_list[i] > fmul(max_sprite_dist, max_sprite_dist)) break;
        a_count++;
        result = bsearch((void*)&dist_list[i], base, count, sizeof(fixed_t), &cmpfunc);
        list_pos = (int)((result - base)/sizeof(fixed_t));
        sprite_list[i] = ShooterLevel->sprites[list_pos];
    }

    Vector2d sprite_dir;
    Vector2d sprite_pos;
    //Les pos des sprites sont cassées....
    for(i = a_count; i >= 0; i--){
        sprite_pos.x = /*sprite_list[i].pos_x*/ fix(4) - player->pos.x;
        sprite_pos.y = /*sprite_list[i].pos_y*/ fix(4) - player->pos.y;
        sprite_dir = fix2DNorml(sprite_pos);

        sprite_dir.x -= player->dir.x;
        sprite_dir.y -= player->dir.y;

        fixed_t inv_d = 1/(fmul(player->plane.x, player->dir.y) - fmul(player->dir.x, player->plane.y));
        fixed_t trans_y = fmul(inv_d, (fmul(player->dir.y, sprite_dir.x) - fmul(player->dir.x, sprite_dir.y)));
        fixed_t trans_x = fmul(inv_d, (fmul(-player->plane.y, sprite_dir.x) + fmul(player->plane.x, sprite_dir.y)));
        int screen_x = (int)(viewport_w * 0.5) * ffloor(0xFFFF + fdiv(trans_x, trans_y));

        if(screen_x <= 0 || screen_x >= viewport_w) continue;

        dist_list[i] = fix(sqrt(f2float(dist_list[i])));
        int spriteHeight = f2int(viewport_h / dist_list[i]); //Taille en px de la ligne
      	spriteHeight = spriteHeight < 1 ? 1 : spriteHeight;
      	fixed_t spriteSize = fix(spriteHeight) / tsize; //taille proportionelle de la ligne a la tex

        /*
        image_scale(sprite, spriteSize, spriteSize, &temp);
        image_linear(sprite, image_at(frame_buffer, screen_x, (int)(viewport_h * 0.5 - spriteHeight * 0.5)), &temp);
        */

    }
    free(dist_list);
    free(sprite_list);
}

void draw_sprites(image_t *sprite, ShooterMap *ShooterLevel, Player *player){
    draw_map_sprites(sprite, ShooterLevel, player);
    //draw_mob_sprites(ShooterLevel)
}
