#include "includes.h"

#ifndef types_h
#define types_h

typedef struct {

  int32_t x, y;

} Vector2d;

typedef struct {

  int32_t x, y, z;

} Vector3d;

typedef struct{

  fixed_t pos_x, pos_y, pos_z;

  uint8_t type;

} Sprite;

typedef struct{

  //size (hardcoded to 128x128 for now)
  //int w, h;

  //Start info
  uint32_t startpos_x; uint32_t startpos_y;
  uint32_t startdir_x; uint32_t startdir_y;
  uint32_t startplane_x;  uint32_t startplane_y;

  //Floor layer data (Unused for now)
  //Floor tile 0;0 is used to say if there is a sky
  //0 == No, >0 is the sky's ID
  uint8_t floor[map_w][map_h];

  //Wall layer data
  uint8_t wall[map_d][map_w][map_h];

  //Sprite layer data
  uint8_t sprite_count;
  Sprite sprites[256];

} ShooterMap;

typedef struct{

  //! C'est en fixed_t !
  Vector3d pos;
  Vector3d velocity; //In tiles/s or 2m/s
  Vector2d dir;
  Vector2d plane;

  //Tout ce qui est ci-dessous peut être modifié pour votre jeu
  fixed_t speed_mult;

} Player;

typedef struct{

  ShooterMap *shooterLevel;

  Player *player;

  int level;

} Game;

#endif
